package baseui;

/**
 * <p>Title: Gestion Affichage et processus</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * @author: Jean-Philippe Rennard
 * @version 1.0
 */

/**  Classe abstraite de gestion du processus */
public abstract class Cprocess implements Runnable {
  static final int TEMPO_DEFAUT=1;
  /** Pointeur sur l'interface utilisateur */
  Cui Ui;
  /** Vue */
  public Cvue vue;
  /** Processus */
  public Thread prThread;
  /** Flag en cours */
  public boolean isRunning;
  /** gnration courante */
  public int generation;
  /** Temporisation */
  public int tempoProcess=TEMPO_DEFAUT;

  /** Constructeur par dfaut */
  public Cprocess() {
  }
  /** Constructeur dans une UI */
  public Cprocess(Cui ui) {
    Ui=ui;
    generation=0;
  }
  /** Dmarrage du processus */
  public void lancement() {
    if(prThread==null)
      prThread=new Thread(this);
    prThread.start();
  }
  /** Boucle principale */
  public void run() {
    Thread ceThread=Thread.currentThread();
    isRunning=true;
    while(prThread==ceThread) {
     geneSuiv();
     try {
        Thread.sleep(tempoProcess);
      } catch (InterruptedException e) { }
    }
  }
  /** Arrt boucle */
  public void stop() {
    prThread=null;
    isRunning=false;
  }
  /** Mise  jour de la valeur de temporisation */
  public void setTempo(int t) {
    tempoProcess=t;
  }
  /** Avance pas--pas */
  public void pasAPas() {
    geneSuiv();
  }
  /** Gnration suivante */
  public abstract void geneSuiv();
  /** Initialisation de la vue graphique */
  public abstract void initVue();
}
