package baseui;

/**
 * <p>Title: Gestion Affichage et processus</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * @author: Jean-Philippe Rennard
 * @version 1.0
 */

import java.awt.*;
import java.awt.event.*;


/**  Classe abstraite de gestion de l'inteface utilisateur */
public abstract class Cui extends Frame {
  /** pointeur sur le processus */
  public Cprocess process;

  /** Constructeur par dfaut */
  public Cui() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /** Initialisation du composant */
  private void jbInit() throws Exception {
  }

  /** Redimensionnement de la vue */
  public void redimUi() {
    if(process.isRunning) {
      synchronized (process) { process.stop(); }
      process.initVue();
      process.lancement();
    }
    else
      process.initVue();
  }
  /** Fermeture fentre */
  void this_windowClosing(WindowEvent e) {
    synchronized (process) { process.stop(); }
    process.vue.destroy();
    dispose();
  }

  /** gestion de l'interface selon marche/arrt */
  public abstract void setInterface(boolean e);
  /** Affichage de la gnration courante */
  public abstract void affGeneration();
}
