package nimapplet;

/**
 * Package nimapplet
 * Jeu de Nim contre un rseau de McCulloch-Pitts.
 * Rseaux Neauronaux, Vuibert 2006.
 * Jean-Philippe Rennard
 * version 1.0, 17/3/2006
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

/**
 * <p>Title: Applet Nim</p>
 * <p>Description: Jeu de Nim contre un rseau de McCulloch-Pitts.</p>
 */
public class NimMP extends Applet {

  /** Pointeur sur l'interface utilisateur */
  NimUI nUI;
  // Data
  String product = "NIM et McCulloch-Pitts";
  String version = "1.0";
  String date = "17 mars 2006";
  String comments = "Jeu de Nim et rseau de McCulloch/Pitts.";
  String auteur = "Jean-Philippe Rennard";
  String editeur = "Rseaux neuronaux et modle objet. Vuibert, ISBN 2-7117-4830-8.";
  String copyright = "Copyright (c) 2006.";
  String GNU1 = new String("This program is free software; you can redistribute it and/or");
  String GNU2 = "modify it under the terms of the GNU General Public License";
  String GNU3 = "as published by the Free Software Foundation.";

  FlowLayout flowLayout1 = new FlowLayout();
  Button btngo = new Button();

  private boolean isStandalone = false;

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public NimMP() {
  }

  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    btngo.setLabel("Go");
    btngo.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btngo_actionPerformed(e);
      }
    });
    this.setLayout(flowLayout1);
    this.add(btngo, null);
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }

  // Lance la fentre de l'applet
  public void launch() {
    Dimension dim= getToolkit().getScreenSize();
    nUI.setSize((int)(0.75*dim.width), (int)(0.75*dim.height));
    nUI.setLocation(20,20);
    nUI.show();
  }

  public void btngo_actionPerformed(ActionEvent e) {
    nUI=new NimUI(this);
    launch();
  }
}
